/* liqbase
 * Copyright (C) 2008 Gary Birkett
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/*
 *
 * speed test module is a place to check out functions in a stable reproducable environment for statistical testing purposes
 *
 */



#include <stdlib.h>
#include <stdio.h>

#include <X11/keysym.h>


#include "liqapp.h"
#include "liqbook.h"
#include "liqcanvas.h"





int liqspeedtest_run()
{
//int res=0;

	



	
	//################################################################
		int fc=0;
		unsigned long t0=app_GetTicks();

		for(fc=0;fc<100;fc++)
			
		{ // test speed
			int n;
			unsigned long ts=app_GetTicks();
			
			for(n=0;n<1000;n++)
				canvas_drawtext(0,0,"Hello world, this is a test");
				
			unsigned long te=app_GetTicks();

			app_log("time %3i   %1.5f    %1.5f        ",fc,app_fps(ts,te,1),app_fps(t0,te,fc));
			
			unsigned long tf=app_GetTicks();
			
			t0=t0 + (tf-te);	// account for sending the printf down the wire...
			
		}

	return 0;
}
